<!DOCTYPE html>
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script> 
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>    
    <title>Task 23b.40</title>
    <style>
        .picture {
            background-image: url("LuckyDiceImages/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>
</head>
<body>
    <div class="container-fluid bg-primary picture ">
        1
    </div>
    <div class="container">
        <div class="row">
            <div class="col-5 bg-white">
                <div class="row form-group"> <!-- có  class="form-group" mới tách được các dòng ra với nhau -->
                    <div class="col-12">
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4  border-success">
                        <label for="">Username</label>
                    </div>
                    <div class="col-8  border-success">
                        <input type="text" id="inp-Username" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4 border-success">
                        <label for="">Firstname</label>
                    </div>
                    <div class="col-8 border-success">
                        <input type="text" id="inp-Firstname" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4 border-success">
                        <label for="">Lastname</label>
                    </div>
                    <div class="col-8  border-success">
                        <input type="text" id="inp-Lastname" class="form-control">
                    </div>
                </div>
            </div>
            <div class="col-4 text-center">
                <div class="row form-group">
                    <div class="col-12">
                        <button onclick="onbtnNemClick()" id="btn-tung-xuc-sac" class="btn btn-success button-with w-75">Ném</button>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <img src="LuckyDiceImages/dice.png" alt="" id="img-dice" class="img-thumbnail" >
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <p id="p-dice"> Chúc mừng </p>
                    </div>
                </div>
            </div>
            <div class="col-3  text-center">
                <div class="row form-group">
                    <div class="col-12 ">
                        <p>Voucher</p>
                        <p id="p-Vouche-id">NoID</p>
                        <p id="P-voucher-persent" >0%</p>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <img src="LuckyDiceImages/xe-may.jpg" alt="" id="img-persent" class="img-thumbnail">
                    </div>
                </div>
            </div>
        </div>
        <div class="row bg-light text-center form-group">
            <div class="col-12">
                <button id="Btn-Dice-History" class="btn btn-info btn-success" onclick="onBtnDiceHistoryClick()">Dice History</button>
                <button id="Btn-Voucher-History" class="btn btn-info btn-success">Voucher History</button>
                <button id="Btn-Persent-History" class="btn btn-info btn-success">Persent History</button>
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <table id="tabel-dice" class="table table-striped table-hover border">
                    <thead>
                        <tr>
                            <th>Lượt</th>
                            <th>Dice</th>
                        </tr>
                    </thead>
                    <tr>
                        <td>1</td>
                        <td>2</td>
                    </tr>
                    <tr>
                        <td>2</td>
                        <td>3</td>
                    </tr>
                    <tr>
                        <td>3</td>
                        <td>4</td>
                    </tr>
                    <tr>
                        <td>4</td>
                        <td>5</td>
                    </tr>
                    <tr>
                        <td>5</td>
                        <td>6</td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
</body>
<script>
    //*** Vùng 1 Nơi khai báo Hàm dùng chung
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const vBASE_URL = "/devcamp-lucky-dice";
    const vUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";

    const gEND_ROW_TABLE = -1;
    // hằng số số thứ tự các cột
    const gCOLUMN_LUOT = 0;
    const gCOLUMN_DICE = 1;
    // Khởi tạo đối tượng dừng chung trong chương trình
    var gUse = {
        username:"",
        firstname:"",
        lastname:""

    }
    //*** Vùng 2 Nơi khai báo Element

    //*** Vùng 3 Nơi Các hàm xử lý sự kiện
    function onbtnNemClick(){
        //B1 Thu thấp dữ liệu
        getDataUser(gUse);
        //B2 Kiểm tra dữ liệu
        var vCheck = viLiData(gUse);
        //console.log(vCheck);
        if(vCheck) {
            // Bước 3 gọi API từ Server
            getDataInServer(gUse)
        }
    }
    // hàm ấn nút Dice History
    function onBtnDiceHistoryClick() {
        console.log("Nút Dice History được ấn ")
        //b1Lấy thong tin
        getDataUser(gUse);
        //b2Kiểm tra
        var vCheck2 = viLiData(gUse);
        if(vCheck2) {
            //b3 Gọi Data từ API
            //var vName = gUse.useName;
                getDataHistory(gUse.username)
        }

    }
    //*** Vùng 3 Nơi xử lý các hàm dùng chung toàn bộ chương trình
    // Hàm thu thấp dữ liệu
    function getDataUser(paramData){
        var vInpUserName =document.getElementById("inp-Username");
        var vInpFirstName = document.getElementById("inp-Firstname");
        var vInpLastName = document.getElementById("inp-Lastname");
        paramData.username = vInpUserName.value.trim();
        paramData.firstname=vInpFirstName.value.trim();
        paramData.lastname=vInpLastName.value.trim();
    }
    // Hàm kiểm tra dữ liệu
    function viLiData(paramData){
        if(paramData.username==""){
            alert("Bạn chưa nhập User Name");
            return false;
        }
        if(paramData.firstname==""){
            alert("Bạn chưa nhập first Name");
            return false;
        }
        if(paramData.lastname==""){
            alert("Bạn chưa nhập Last Name");
            return false;
        }
        return true;
    }
    // hàm gọi dữ liệu từ Server
    function getDataInServer(paramData){
        var vDataDice = new XMLHttpRequest()
        vDataDice.open("POST", vBASE_URL + "/dice", true);
        vDataDice.setRequestHeader("Content-Type", vUTF8_TEXT_APPLICATION_HEADER);
        vDataDice.send(JSON.stringify(paramData));  //chuyển Json object sang string
        
        vDataDice.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                // hàm xử lý khi trả về dữ liệU thành công
                //B4 Xử lý dữ liệu trả về từ Server
                
                procesResponse (vDataDice);
            }
        }
    }
    // Hàm trả về dữ liệu từ API 
    function procesResponse(paramData) {
        var vResponse = JSON.parse(paramData.responseText);
        //console.log(paramData.responseText);
        var vDiceReady = vResponse.dice;
        //console.log("dice result:= " + vDiceReady);
        //console.log("prize result:= " + vResponse.prize);
        //console.log(typeof(vResponse));
        //Hiên thị Dice
        changeDice(vDiceReady);
        // Hiển thị lời nhắn
        changeMessage(vDiceReady);
        // Hàm hiên thị Voucher
        changVoucher(vResponse);
        // hiển thị ảnh phần thưởng
        changImg(vResponse);
    }
    // Hàm hiển thị Dice
    function changeDice(paramDice) {
        var vImgDice = document.getElementById("img-dice");
        switch(paramDice){
            case 1 :  // case value_1 do some thing
                vImgDice.src = "LuckyDiceImages/1.png";
                break;
            case 2 : 
                vImgDice.src = "LuckyDiceImages/2.png";
                break;
            case 3 : 
                vImgDice.src = "LuckyDiceImages/3.png";
                break;
            case 4 : 
                vImgDice.src = "LuckyDiceImages/4.png";
                break;
            case 5 : 
                vImgDice.src = "LuckyDiceImages/5.png";
                break;
            default: 
                vImgDice.src = "LuckyDiceImages/6.png";
            }
        }
    // Hiển thị lời nhắn
    function changeMessage(paramMesage){
        var vInpMessage = document.getElementById("p-dice");
        if(paramMesage < 4) {
            vInpMessage.innerHTML = ("Chúc bạn may mắn lần sau");
        }
        else {
            vInpMessage.innerHTML = ("Chúc mừng hãy chơi tiếp lần nữa");
        }
    }
    // hàm hiển thị Voucher 
    function changVoucher(paramVoucher) {
        var vInpVoucher = document.getElementById("p-Vouche-id");
        var vInpPersent = document.getElementById("P-voucher-persent");
        if(paramVoucher.voucher!=null){
            vInpVoucher.innerHTML = paramVoucher.voucher.maVoucher;
            vInpPersent.innerHTML = paramVoucher.voucher.phanTramGiamGia +"%"
        }
        else {
            vInpVoucher.innerHTML = "";
            vInpPersent.innerHTML = "";
        }
    }
    // Hiển thị ảnh phần thưởng
    function changImg(paramIMG){
        var vInpImg = document.getElementById ("img-persent");
        switch(paramIMG.prize){
            case "Mũ":  // case value_1 do some thing
                vInpImg.src = "LuckyDiceImages/hat.jpg";
                break;
            case "Áo": 
                vInpImg.src = "LuckyDiceImages/t-shirt.jpg";
                break;
            case "Xe máy" : 
                vInpImg.src = "LuckyDiceImages/motobike.jpg";
                break;
            case "Ô tô": 
                vInpImg.src = "LuckyDiceImages/car.jpg";
                break;
            default:
                vInpImg.src = "LuckyDiceImages/no-present.jpg";
    }
  }
  // hàm gọi dữ liệu lịch sử dice từ Server
  function getDataHistory(paramData){

        var vXmlHttpDiceHistory = new XMLHttpRequest();
        vXmlHttpDiceHistory.open("GET", vBASE_URL + "/dice-history?username=" + paramData, true);
        vXmlHttpDiceHistory.send();
        vXmlHttpDiceHistory.onreadystatechange =function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    //console.log(vXmlHttpDiceHistory.responseText);
                    //b4 hàm xử lý dữ liệu
                    xuLyDuLieu(vXmlHttpDiceHistory)

                }
            }
        }

        // xủ lý dữ liệu
    function xuLyDuLieu(paramData){
        var vDataHistory = JSON.parse(paramData.responseText);
        console.log(vDataHistory);
        // xoá hàng trong bang
        var vtable = document.getElementById("tabel-dice");
        clearTable(vtable);
        // Hiên thị dữ liệu
        hienThiDuLieu(vDataHistory.data);
    }
    // hàm xoá bảng
    function clearTable(paramTable){
        var rows = paramTable.rows;
        var i = rows.length;
        while (--i) {
        rows[i].parentNode.removeChild(rows[i]);
        // or
        // table.deleteRow(i);
        }
    }
    // hàm đỏ dữ liệu mới vào bảng
    function hienThiDuLieu(paraData){
        console.log(paraData);
        var vTable = document.getElementById("tabel-dice");
        var vTableBody = vTable.getElementsByTagName("thead")[0];
        for ( var bI = 0; bI < paraData.length ; bI++) {
            // khai báo một biên chứa giá trị của các đối tượng thứ bI
            var vUses = paraData[bI];
            var vRow = vTableBody.insertRow(gEND_ROW_TABLE);
            var vCellLuot = vRow.insertCell(gCOLUMN_LUOT); // gián giá trị cột UserID vị trí thứ 0 lần lượt làm cho các cột còn lại.
            var vCellDice = vRow.insertCell(gCOLUMN_DICE);
            // gán giá trị
            vCellLuot.innerHTML = bI + 1
            vCellDice.innerHTML = paraData[bI].dice
        }
    }


</script>
</html>